/*====================================================================
Project: From Access to Achievement: The Primary-School-Age Impacts of 
		 an At-Scale Preschool Construction Program in Highly Deprived 
		 Communities
Authors: Marina Bassi, Bruno Besbas, Lelys Dinarte, 
		 Saravana Ravindran and Ana Reynoso
----------------------------------------------------------------------
Modification Date: 06 May 2024
 
Do-files: 	Juan Fernando Duque-Giraldo
			juanduquegiraldo@gmail.com
====================================================================*/

	clear all
	set seed 123
	
// 	Defining directory
	** PUT HERE THE MAIN DIRECTORY
	glo maindir "your directory"
	set varabbrev on

// 	Directory globals
	glo dofiles "${maindir}/codes"
	glo data 	"${maindir}/data"
	
	sysdir set PLUS "$dofiles/ado"

 *UNCOMMENT IF NECESSARY
 * the ado folder with all the dependencies is provided 
 * however, sometimes there is a mistake 3939 originated from the outreg
 * dependencie, if you face that error, do ado uninstall outreg and uncomment 
 * the following lines.
 /*
// 	INSTALL PACKAGES
	ssc install wyoung, replace
	ssc install ritest, replace
	net install tabmiss, from(https://stats.oarc.ucla.edu/stat/stata/ado/analysis)
	ssc install outreg, replace
	net install st0085_1, from(http://www.stata-journal.com/software/sj7-2)
	net install dm89_2, from(http://www.stata-journal.com/software/sj15-4)
	ssc install schemepack, replace
	ssc install unique, replace
	ssc install coefplot, replace
*/

// 	CHANGE AS NEEDED (CAVEAT: COULD BE VERY TIME CONSUMING)
	glo reps 	= 1 //0000 	// 10000 Reps for WYOUNG command
	glo reps_ri = 2 //000 	// 2000 Reps for RITEST command
	glo wgt "equal_weights" // WEIGHTS for the regressions
	glo ind "zi"			// For indices names

// 	TABLES
	do "${dofiles}\01_Table 1.do"
	do "${dofiles}\02_Table 2.do"
	do "${dofiles}\05_Table 3.do"
	do "${dofiles}\06_Table 4.do"
	do "${dofiles}\07_Table 5.do"
	do "${dofiles}\08_Table 6.do"
	do "${dofiles}\09_Table 7.do"
	do "${dofiles}\11_Table A1.do"
	do "${dofiles}\12_Table A3.do"
	do "${dofiles}\13_Table A4.do"
	do "${dofiles}\14_Table A5.do"
	do "${dofiles}\15_Table A6.do"
	do "${dofiles}\16_Table A7.do"
	do "${dofiles}\17_Tables A8-A13.do"
	do "${dofiles}\18_Tables A14-A19.do"
	
//	FIGURES
	do "${dofiles}\03_Figure 2.do"
	do "${dofiles}\04_Figure 3.do"
	do "${dofiles}\10_Figure A2.do"
	
