/*====================================================================
Project: Early Childhood Development and School-Age Performance
Authors: Marina Bassi, Bruno Besbas, Lelys Dinarte, 
		 Saravana Ravindran and Ana Reynoso
----------------------------------------------------------------------
Modification Date: 09 Jan 2024
 
Do-file: Juan Fernando Duque-Giraldo    
====================================================================*/

// Load data
	use "${data}\data_EL.dta", clear
	
// Add variable labels
	do "${dofiles}\DICIPE_VarLabels.do"

*-------------------------------------------------------------------------------*
*								FIGURE A2										*
*-------------------------------------------------------------------------------*
// Figure A2: Distribution of Ages for Target Children at Baseline
	unique ageinmonth if istarget35==1
	histogram ageinmonth if istarget35==1, percent width(1) color(navy%40) xlabel(36(2)59) /*xlabel(#24)*/ ylabel(#6, angle(h)) graphregion(color(white)) /*title("Age in months at baseline") subtitle("Target child")*/ xtitle("Age of target child at baseline (months)")
	*graph export "${out}\TargetChildAge_distribution.png", as(png) replace
/*
Notes: The figure presents the distribution of ages for target children at baseline in months
*/